#include "Globals.h"
#include "EventHandler.h"

void EventHandler::processEvent(HWND window, Type type, int param1, int param2)
{
	if ((type != keyup) && (type != keydown)) {
		getAbsolutePos(window, param1, param2);
	}

	switch(type) {
	case keyup: {
		short keyval = VkKeyScan((char) param1);
		keybd_event(LOBYTE(keyval), MapVirtualKey(LOBYTE(keyval), 0), KEYEVENTF_KEYUP, 0);
		break;
	}
	case keydown: {
		short keyval = VkKeyScan((char) param1);
		keybd_event(LOBYTE(keyval), MapVirtualKey(LOBYTE(keyval), 0), 0, 0);
		break;
	}
	case lup:
		mouse_event(MOUSEEVENTF_LEFTUP, param1, 
					param2, 0, 0);
		break;
	case ldown:
		mouse_event(MOUSEEVENTF_LEFTDOWN, param1, 
					param2, 0, 0);
		break;
	case rup:
		mouse_event(MOUSEEVENTF_RIGHTUP, param1, 
					param2, 0, 0);
		break;
	case rdown:
		mouse_event(MOUSEEVENTF_RIGHTDOWN, param1, 
					param2, 0, 0);
		break;
	case move:
		mouse_event(MOUSEEVENTF_ABSOLUTE | MOUSEEVENTF_MOVE, param1, 
					param2, 0, 0);
		break;
	}						
}

void EventHandler::getAbsolutePos(HWND window, int& x, int& y)
{
	RECT rc;

	x -= BORDER_SIZE; // this is to account for empty space on the browser client window
	y -= BORDER_SIZE;

	y += TITLE_HEIGHT;

	GetWindowRect(window, &rc);
	x = 65536 / GetSystemMetrics(SM_CXSCREEN) * 
					(x + rc.left);
	y = 65536 / GetSystemMetrics(SM_CYSCREEN) * 
					(y + rc.top);
}
