#ifndef __SCREENSCRAPER_H_
#define __SCREENSCRAPER_H_

#include <windows.h>
#include <string>
#include "BaseThread.h"
#include "BitmapConverter.h"
#include "StreamSocket.h"

using namespace std;

class ScreenScraper : public BaseThread 
{
private:
	char			*_frameBuffer;
	char			*_frameBufferPrev;
	unsigned long	_bufferLen;
	string			_updateList;

	HDC			_scrContext, _memContext;
	HBITMAP		_memBitmap, _scrBitmap;
	HWND		_window;
	BITMAPINFO	_bmi;
	int			_width, _height;

private:
	BOOL prepareContext();
	void restoreContext();
	inline void captureScreen();
	void getUpdates();
	bool detectChange(int tile);

protected:
	virtual void run();

public:	
	ScreenScraper();
	~ScreenScraper();
	
	void attach(string program);
	void startUpdates(StreamSocket *socket);
	void sendImage(int tile, int socket);
	HWND getWindow() {
		return _window;
	}

private:
	BitmapConverter	_converter;
	StreamSocket	*_clientSocket;
	bool			_stopUpdates;
	HANDLE			_stopEvent;
};	

#endif