#ifndef __SCREENSERVER_H_
#define __SCREENSERVER_H_

#include "StreamSocket.h"
#include "ScreenScraper.h"
#include "EventHandler.h"

using namespace std;

class ScreenServer
{
public:
	ScreenServer();

	void start();
	void runSession();

protected:
	void readRequest(string& file);
	void sendHeader(string& contentType);
	void sendUpdates();
	bool detectChange(int tile);
	void sendImage(int tile);
	void sendFile(string& file);
	void handleEvent(string& request);
	void sendError();

protected:

	StreamSocket	_socket;
	StreamSocket	*_clientSocket;
	ScreenScraper	_scraper;
	EventHandler	_eventHandler;
};

#endif